#!/usr/bin/perl -w
#content       creates the syntax specific c++-code from a .spec file
#              (i.e. vtql.syntax.spec) and writes it to a .inc file.
#homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
#Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use strict;

my $i=0;

my $INC_PART=1;
if($ARGV[0] eq "exec"){
 $INC_PART=0;
 shift;
}
print "//This file is genereated from $ARGV[0]. Do not edit!\n\n";
while(defined(my $line=<>)){
 chop $line;$line =~ s/\#.*$//g;

 if($line !~  /^[ 	]*$/){
  my @L=split(/:/,$line,3);
  $L[0] =~ s/[ 	]*\(/{/g;$L[0] =~ s/\)[ 	]*/},/g;
  $L[1] =~ s/[ 	]+//;

  if($INC_PART){
   print " SINGLE_COMMAND a_single_command_id_",$i,"[]={$L[0]\{\"\",-1}};\n";
  }else{
   my @mode=split("\\\$",$L[1]);
   my @cmd=split("\\\$",$L[2]);
   die "#modes!=#commands : $#mode!=$#cmd" if(@cmd!=@mode);
   for(my $j=0;$j<@mode;$j++){
    foreach my $m (split("%",$mode[$j])){
     print "# if defined(INC_",$m,")\n";
     print "  EXEC_COM(",$i,",",$m,",",$cmd[$j],")\n";
     print "# endif\n";
    }
   }
  }
  $i++;
 }
}

if($INC_PART){
print " ALL_COMMANDS={\n";
for(my $j=0;$j<$i;$j++){
 print "  {a_single_command_id_$j},\n"
}
print "  {NULL_COMMAND}\n };\n";
}
