//content       handles i/o in threads
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include <libvtql/sock.h>
#include <libvtql/thread_util.h>
#include <readline/history.h>
#include <readline/readline.h>

class IO{
 public:
  IO(thread::Semaphore& _s):sem(_s),f(10000){};

  operator char(){
   char c;
   const char* cp=f.Get_Start(false);
   if(!cp)return 0;
   c=*cp;
   f.Get_End(true);
   return c;
  }
 protected:
  void Add(const char* cpI=NULL){
   if(!cpI){++sem;return;}
   for(const char* cpN=cpI;*cpN;++cpN)Add(*cpN);
  } 
  void Add(char cI){
   char* cp=f.Put_Start(true);
   (*cp)=cI;
   f.Put_End(true);
   ++sem;
  }

 private:
  thread::Semaphore& sem;
  thread::FiFo<char> f;
};

class Output:public IO,public thread::Thread{
 public:
  Output(thread::Semaphore& _s,sock::Socket_basic& _so,bool b1):
   IO(_s),socket(_so),iGreeting(b1?2:0){};
  virtual void* Run(){
   sock::PollClass p;p.AddSocket(socket,POLLIN);
   while(!ExitRun()){
    p.Run(-1);
    char c;
    if(read(socket,&c,1)!=1){socket.Close();Add();return NULL;}
    if(iGreeting){ 
     if(c=='\n')--iGreeting;
     else if(iGreeting<2)++iGreeting;
    }else Add(c);
   }
   socket.Close();
   return NULL;
  }

 private:
  sock::Socket_basic& socket;
  int iGreeting;
};

class Input:public IO,public thread::Thread{
 public:
  Input(thread::Semaphore& _s,bool b1,bool b2):
   IO(_s),bNoQuit(b1),bTTY(b2){if(bTTY)using_history();}

  virtual void* Run(){
   while(!ExitRun()){
    if(bTTY){
     char* cp=readline(NULL);
     if(!cp){if(!bNoQuit)Add("QUIT\n");return NULL;}
     add_history(cp);
     Add(cp);Add('\n');
     std::free(cp);
    }else{
     int i=getchar();
     if(i==EOF){if(!bNoQuit)Add("QUIT\n");return NULL;}
     Add(char(i));
    }
   }
   return NULL;
  }

 private:
  bool bNoQuit,bTTY;
};
