//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include <signal.h>
#include <iostream>
#include <unistd.h>
#include "server.h"
#include "glob_defs.h"
#include "../config.h"

#ifdef DEBUG
static void mySIG_IGN(int iSig){DGPR(iSig);}
#endif
static int Usage(bool b){
 (b?(std::cerr):(std::cout)) << glob_defs::cpCmdLineHelp << std::flush;
 return b?1:0;
}


int main(int iArgs,char** cppArgs){
 std::string sSockname; 
 if(iArgs==2){
  std::string s1=cppArgs[1];
  if(s1[0]!='-')sSockname=cppArgs[1];
  else if(s1=="-v" || s1=="--version"){
   std::cout << glob_defs::cpVersion << std::endl;
   return 0;
  }else if(s1=="-h" || s1=="--help")return Usage(false);
  else return Usage(true);
 } else if(iArgs==3 && std::string(cppArgs[1])=="--" )sSockname=cppArgs[2];
 else return Usage(true);

 try{
  Server server;
  server.Add(0,sSockname);
  server[0].SetMod(VTQL::UM_CONFIG);
  server[0].Listen();
  switch(fork()){ 
   case -1:throw Error::Runtime(METH_NAME,"cannot fork");
   case 0:{
    #ifndef DEBUG
    close(0);close(1);setsid();
    signal(SIGHUP,SIG_IGN);
    signal(SIGPIPE,SIG_IGN);
    #else
    signal(SIGHUP,mySIG_IGN);
    signal(SIGPIPE,mySIG_IGN);
    #endif

    server.Handle();
    break;
   }
   default:server[0].GetFD();break;
  }
 }catch(Error::base err){std::cerr << "fatal: " <<std::string(err)<<std::endl;}
 
 return 0;
}


