//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include "connection.h"

#include <unistd.h>
#include <libvtql/vtql_utils.h>
#include "vtpage.h"

Connection_base::Outp_C::Outp_C(const sock::Socket_basic& s,size_t iS):
 Output(s,iS),cpTT(new char[vt_tv::VT_WIDTH*2+1]){};

void Connection_base::Outp_C::GetPage(const u_int8_t* cp,VTQL::ShowMode d){
 if(d==VTQL::SM_LIST)return;

 //nothrow
 for(size_t i=0;i<vt_tv::VT_HEIGHT;++i){
  vt_tv::ProcessVTLine pvl(cp,cpTT);
  cp+=vt_tv::VT_WIDTH;
  switch(d){
   case VTQL::SM_HEX :pvl.Process_Hex();break;
   case VTQL::SM_TEXT:pvl.Process_Txt(!i);break;
   case VTQL::SM_LIST:break;
  };
  Add(std::string(cpTT));
 }
 //end of nothrow
}

bool Connection_base::Poll(bool& bR,bool& bW)const{
 sock::PollClass p;
 p.AddSocket(Con,(bW?POLLOUT:0)|(bR?POLLIN:0));
 if(p.Run()<=0){bW=false;bR=false;return true;}

 if(p.Test(0,POLLHUP|POLLNVAL)){bW=false;bR=false;return false;}
 if(!p.Test(0,POLLOUT))bW=false;
 if(!p.Test(0,POLLIN))bR=false;
 return true;
}

