//content       definition of the database
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#ifndef DB_H
#define DB_H

#include <map>
#include <string>
#include <list>
#include <libvtql/thread_util.h>
#include <libvtql/smartptr.h>
#include "region.h"
#include "station.h"
#include <libvtql/sock.h>

namespace vt_tv{class PageTyp;}

class Database{
 public:
  SearchQueue sqSearch;

  void Insert(const vt_tv::PageTyp&);
  void GetPageL(size_t,SearchQueue::SmartRP);

  StationTyp& operator[](size_t);
  void AddStation(size_t);
  void DelStation(size_t);
 
  friend void operator <<(sock::Output&,const Database&);

  typedef SearchQueue::SqPageTyp CallBType;
  thread::CallBack<CallBType> cb;
 private:
  typedef CachedExternIDMap<StationTyp> StationMap;
  StationMap smStations;
};  

#endif 
