//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include "region.h"
#include "glob_defs.h"

Region::Region()
:Region_basic(std::vector<size_t>(glob_defs::ipRegionBases,
 glob_defs::ipRegionBases+5)){};

void Region::NewString(std::string sPat,const std::string& sMode){
 spsFastFind.clear();
 Region_basic::NewString(sPat,sMode);
 for(SingleRange::const_iterator i1=rvAll[2].begin();i1!=rvAll[2].end();++i1)
  if(i1->first==i1->second)
   for(SingleRange::const_iterator i2=rvAll[3].begin();i2!=rvAll[3].end();++i2)
    if(i2->first==i2->second)
     spsFastFind.push_back(vt_tv::VTPage_ID(i1->first,i2->first));
    else{spsFastFind.clear();return;}
  else{spsFastFind.clear();return;}
}

void Region::PageData_VT::GetLine(size_t i,char* cpT)const{
  vt_tv::ProcessVTLine pvt(cp+i*vt_tv::VT_WIDTH,cpT);
  pvt.Process_Txt(!i);
}

#include "error_class.h"
void SearchQueue::Add2Queue(const SingleResult& sr,SmartRP rp){
 if(!sr.bEnd && !rp->MatchVTPgInfo(sr.page))return;

 if(rp->HasTextSearch()){
  m.Lock();
  mmQuery.AddIf(sr.iRegID,new MultQuery(rp));
  if(!sr.bEnd)mmQuery[sr.iRegID]->pgl.push_back(sr.page);
  ++sQueue;
  m.UnLock();
 }else cbMatch.Run(sr);
}

void SearchQueue::ManageThread(bool bStart){
 if(bStart){
  if(!Start<SearchQueue>())
   throw Error::Runtime(METH_NAME,"cannot start thread");
 }else{Stop();++sQueue;}
}

void* SearchQueue::Run(){
 size_t iRegID=0;
 while(!ExitRun()){
  sQueue.Wait();
  m.Lock();

  iRegID=mmQuery.Get_NxtID(iRegID);
  SmartRP rp=mmQuery[iRegID]->rp;

  SingleResult pg(iRegID,true);
  if(!mmQuery[iRegID]->pgl.empty()){
   pg=SingleResult(iRegID,mmQuery[iRegID]->pgl.front());
   mmQuery[iRegID]->pgl.pop_front();
  }else mmQuery.erase(iRegID);

  m.UnLock();

  if(pg.bEnd || rp->MatchTxt(Region::PageData_VT(pg.page.PD->pmd)))
   cbMatch.Run(pg);
 }
 return NULL;
}

size_t SearchQueue::MultiQueryMap::Get_NxtID(size_t i){
 iterator j=mD.upper_bound(i);
 if(j==mD.end())j=mD.begin();
 return j->first;
}
