//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include "vtpage.h"
#include <iostream>

namespace vt_tv{

const unsigned VT_HEIGHT=25;
const unsigned VT_WIDTH =40;
const unsigned VT_SIZE  =VT_HEIGHT*VT_WIDTH;

const int ANY_SUB=0x3f7f;           // universal subpage number

VTPage_Info::VTPage_Info(u_int16_t i1,u_int16_t i2):
 VTPage_ID(i1,i2),iFreq(-1),tTime(0),iFlags(0){};

#define NEW_VTSIZE new u_int8_t[VT_SIZE]
#define DEL_VTSIZE(p) delete[] p

PageTyp::PageFD::PageFD():pmd(NEW_VTSIZE){};
PageTyp::PageFD::PageFD(const PageFD& p):pmd(NEW_VTSIZE){
 memcpy(pmd,p.pmd,VT_SIZE);
}
PageTyp::PageFD::~PageFD(){DEL_VTSIZE(pmd);}

PageTyp::PageFD& PageTyp::PageFD::operator =(const PageFD& p){
 memcpy(pmd,p.pmd,VT_SIZE);
 return *this;
}

PageTyp::PageTyp():VTPage_Info(),PD(new PageFD){};
PageTyp::PageTyp(const PageTyp& p):VTPage_Info(p),PD(p.PD){}
PageTyp::~PageTyp(){}

PageTyp& PageTyp::operator =(const PageTyp& p){
 VTPage_Info::operator =(p);
 PD=p.PD;
 return *this;
}

void PageTyp::operator <<(const PageTyp& p){
 VTPage_Info::operator =(p);
 (*PD)=(*p.PD);
}

PageTyp::PageTyp(const VTPage_Info& p):VTPage_Info(p){};

void ProcessVTLine::Process_Hex(){
 for(unsigned x=0; x<VT_WIDTH;++x,++cpIn){
  WriteChar(((*cpIn)/16>9)?('A'+(*cpIn)/16-10):('0'+(*cpIn)/16));
  WriteChar(((*cpIn)%16>9)?('A'+(*cpIn)%16-10):('0'+(*cpIn)%16));
 }
 WriteChar('\0');
}

void ProcessVTLine::Process_Txt(bool b1stLine){
 bool bHold=false,bGraph=false;
 u_int8_t cLast=' ';

 for(unsigned x=0;x<VT_WIDTH;++x,++cpIn){
  u_int8_t cAct=' ';
  switch (*cpIn){
   case 0x00 ... 0x07:bGraph=false;break;
   case 0x08 ... 0x0f:break;
   case 0x10 ... 0x17:bGraph=true;break;
   case 0x18 ... 0x1d:break;
   case 0x1e:bHold=1;break;
   case 0x1f:bHold=0;break;
   default:cAct=(*cpIn);break;
  }

  if(b1stLine)bHold=bGraph=false;

  switch(*cpIn){
   case 0x0e:case 0x0f:case 0x1b:break;
   default:if(bHold && bGraph)cAct=cLast;break;
  } 
  if(bGraph && (cAct&0xa0)==0x20){
   cLast=cAct;
   cAct+=(cAct&0x40)?32:-32;
  }

  switch(cAct){ //special char substitution
   case 0x00:case 0xa0:case 0x7f:case 0xb8:WriteChar(' ');break;
   default:WriteChar(bGraph?' ':cAct);break;
  }
 }
 WriteChar('\0');
}

};
