//content       "stand alone" c++ warper to alevt
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#ifndef VTPAGE_H
#define VTPAGE_H

#include <vector>
#include <stdint.h>
#include <ctime>
#include <libvtql/smartptr.h>
#include <libvtql/sock.h>

namespace vt_tv{ 

extern const unsigned VT_HEIGHT;//=25;
extern const unsigned VT_WIDTH;//=40;
extern const unsigned VT_SIZE;//=VT_HEIGHT*VT_WIDTH;

extern const int ANY_SUB;// universal subpage number

struct VTPage_ID{
 virtual ~VTPage_ID(){};

 VTPage_ID(u_int16_t i1=0,u_int16_t i2=0):iPage(i1),iSPage(i2){};

 bool operator < (const VTPage_ID& p)const{   //not virtual to be fast
  return ((iPage==p.iPage)?(iSPage<p.iSPage):(iPage<p.iPage));
 }

 u_int16_t iPage,iSPage;  //page and subpage nr ('Page 100' == 0x100 == 256)
} __attribute__((packed));

struct VTPage_Info:VTPage_ID{
 virtual ~VTPage_Info(){};

 VTPage_Info(u_int16_t i1=0,u_int16_t i2=0);

 int iFreq;         //iFreq<0: invalid page, iFreq==0: unknown freq
 time_t tTime;      //system unix time of recieval
 u_int8_t iFlags;   //xor'd PG_* , see extern/vt.h
 u_int8_t iLang;
 typedef std::vector<VTPage_ID> VTPage_FastLinks;
 VTPage_FastLinks lpiLinks;

 friend void operator <<(sock::Output&,const VTPage_Info&);
} __attribute__((packed));

struct PageTyp:VTPage_Info{
 PageTyp();
 PageTyp(const PageTyp&);
 virtual ~PageTyp();

 PageTyp& operator =(const PageTyp&);
 void operator <<(const PageTyp&); //real copy

 PageTyp(const VTPage_Info&);

 struct PageFD;
 typedef SmartPtr<PageFD> SmartPD;
 SmartPD PD;
} __attribute__((packed));

struct PageTyp::PageFD{
 PageFD();
 PageFD(const PageFD&);
 PageFD& operator=(const PageFD&);
 virtual ~PageFD();

 u_int8_t* pmd;
} __attribute__((packed));


struct ProcessVTLine{
 //deocode page data to tagged characters, pure text or hexadecimal string
 const u_int8_t* cpIn;
 char* cpOut;
 ProcessVTLine(const u_int8_t* cp1,char* cp2):cpIn(cp1),cpOut(cp2){};

 //raw vt processing double_line=Process(allow_double_lines)
 void Process_Hex();
 void Process_Txt(bool);

 void WriteChar(const char& c){(*cpOut)=c;++cpOut;}
};

};
#endif
