//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#include "wait.h"

#include "glob_defs.h"
#include <libvtql/sock.h>

void SockWait::ManageThread(bool bStart){
 if(bStart){
  if(!Start<SockWait>())throw Error::Runtime(METH_NAME,"cannot start thread");
 }else{Stop();++sRestart;}
}

void SockWait::Clear(){bClear=true;lAddS.clear();}

void SockWait::AddSocket(int i1,short i2){
 lAddS.push_back(std::make_pair(i1,i2));
}

void SockWait::Restart(){
 sRestart.ForceZero();
 ++sRestart;
}

void* SockWait::Run(){
 sock::PollClass pc;
 Lock();
 while(!ExitRun()){
  if(bClear){pc.Clear();bClear=false;}

  for(AddSockList::const_iterator i=lAddS.begin();i!=lAddS.end();++i)
   pc.AddSocket(i->first,i->second);
  lAddS.clear();

  int iW=iWait;
  UnLock();

  cbPoll.Run(pc.Run(iW));
  sRestart.Wait();
  Lock();
  sRestart.ForceZero();
 }
 UnLock();
 return NULL;
}

template <> 
void WaitClass::TCB<SearchQueue::SingleResult>::operator()(const SearchQueue::SingleResult&){p->AddEvent(true);}

template <> 
void WaitClass::TCB<int>::operator()(const int& i){p->AddEvent(i);}

WaitClass::PgCB::PgCB(WaitClass* _p):p(_p),fifo(glob_defs::iVTBufferS){};

void WaitClass::PgCB::operator()(const vt_tv::PageTyp& vtp){
 vt_tv::PageTyp* vtpTar;
 while(!(vtpTar=fifo.Put_Start(false))){
  fifo.Get_Start(true);
  fifo.Get_End(true);
 }
 (*vtpTar) << vtp;
 fifo.Put_End(true);
 p->AddEvent(false);
}

bool WaitClass::Wait(){
 bool bSockEv=false;
 sAnyEv.Wait();
 if(sSockEv.TryW()){
  bSockEv=true;
  sSockEv.ForceZero();
 }
 sAnyEv.ForceZero();
 return bSockEv;
}

void WaitClass::AddEvent(bool bSockEv){
 sAnyEv.Post();
 if(bSockEv)sSockEv.Post();
}
