//content       Wait4Event classes
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#ifndef WAIT_H
#define WAIT_H

#include <list>
#include <libvtql/thread.h>
#include "vtpage.h"
#include "region.h"

class SockWait:protected thread::Thread{
 public:
  SockWait():iWait(0),bClear(true){};

  typedef thread::CallBack<int> SockCallB;
  SockCallB cbPoll;

  void Lock(){mL.Lock();}
  void UnLock(){mL.UnLock();}

  //use this functions only if locked
  void SetWait(int i=0){iWait=i;}
  virtual void Clear();
  virtual void AddSocket(int,short);
  void Restart();

  void ManageThread(bool);
  virtual void* Run();
 private:
  thread::Mutex mL;
  int iWait;

  bool bClear;

  typedef std::list<std::pair<int,short> > AddSockList;
  AddSockList lAddS;

  thread::Semaphore sRestart;
};

class WaitClass{
 public:
  template <typename T>
  struct TCB:thread::CallBack<T>::CBFunct{
   WaitClass* p;
   TCB(WaitClass* _p):p(_p){};
   virtual ~TCB(){};
   virtual void operator()(const T&);
  };
  TCB<SearchQueue::SingleResult> cbSearch; 
  TCB<int> cbSocket;

  struct PgCB:thread::CallBack<vt_tv::PageTyp>::CBFunct{
   WaitClass* p;
   PgCB(WaitClass* _p);
   virtual ~PgCB(){};
   virtual void operator()(const Arg&);
 
   thread::FiFo<Arg> fifo;
  } cbPage;

  WaitClass():cbSearch(this),cbSocket(this),cbPage(this){};
  bool Wait(); //event on socket?

  void AddEvent(bool b);
 private:
  thread::Semaphore sAnyEv,sSockEv;
};

#endif
