//content       handle a list of pages
//homepage      http://www.rzuser.uni-heidelberg.de/~mkleinma/VTQL/
//Copyright (C) 2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>

#ifndef PAGE_LIST_H
#define PAGE_LIST_H

#include <libvtql/vtql_query.h>
#include <libvtql/vtql_event.h>
#include <libvtql/smartptr.h>

extern const size_t PG_INVALID;


class PageList{
 public:
  PageList(VTQL::Query_generic& q,VTQL::Event_generic& e,bool& b):
   query(q),event(e),bWaiting(b),iPos(0){};

  operator VTQL::PgInfo()const;
  void operator ++();
  void operator --();
  void Latest();
  void Search(int,int,int);
  void Search(int,const std::string&);
  void ShowPos()const;
  void ShowList()const;

 private:
  VTQL::Query_generic& query;
  VTQL::Event_generic& event;
  bool& bWaiting;

  SmartPtr<VTQL::QM_PageL> pglp;
  VTQL::QM_PageL::iter iter;
  int iPos;
};
#endif
