//this a simple example application for libvtql, to show, how to write
//a simple applications.
//build with: 
//$ g++ -pthread -I../../ simple.cc -o simple ../libvtql.a 
//call it e.g. with:
//$ ./simple ARD 100
#include <libvtql/vtql_query.h>
#include <cstdio>
#include <cstdlib>
using namespace VTQL;

//search a station by name
int Station_lookup(Query_generic& con,std::string s){
 QM_Stations stations(con);
 stations.Wait();
 QM_Stations::iter i;
 for(i=stations.sm.begin();i!=stations.sm.end();++i)
  if(i->second.sName==s)return i->first;
 std::puts("station not found");
 exit(1);
}

int main(int argc,char** argv){
 if(argc!=3){std::puts("Usage: simple station_name page");return 1;}

 //catch errors
 try{
 //open a query connection
 Query_generic connection("/tmp/vtql-socket");

 //get the station id and make a string from it
 char cpdummy[100]; 
 std::sprintf(cpdummy,"%i..",Station_lookup(connection,argv[1]));

 //start the search and limit to 10 output pages
 QM_PageAlevt page(connection,std::string(cpdummy)+argv[2],10);
 page.Wait();
  
 //output any page in pretty ansi format
 for(QM_PageAlevt::iter j=page.li.begin();j!=page.li.end();++j)
  std::puts(j->second.GetAnsi().c_str());

 }catch(Error::base e){
  puts(std::string(e).c_str());
  return 1;
 }

 return 0;
}
