//Copyright (C) 2000-2002 Matthias Kleinmann <Matthias.Kleinmann@gmx.de>
#include "vtql_query.h"
#include "error_base.h"

using namespace VTQL;
using std::make_pair;

Query_generic::Query_generic(const std::string& s):
 Connect(s),iLC(-1),iReadID(0),iWriteID(0),bBuff(false){};
Query_generic::Query_generic(const sock::Socket_basic& s):
 Connect(s),iLC(-1),bBuff(false){};


bool Query_generic::Process(bool bWait){
 Poll(bWait);

 while(iLC<0 && InpLineC())if(FetchLine().empty())iLC=0;
 if(iLC<0)return false;
 
 while(InpLineC()){
  if(!bBuff)++iReadID;
  std::string s=FetchLine();
  if(s=="ERROR"  ){
   cb.Run(make_pair(-2,sBuff));
   iLC=0;bBuff=false;sBuff="";return true;
  }else if(s=="VOID"   ){
   cb.Run(make_pair(-1,""));
   iLC=0;bBuff=false;sBuff="";return true;
  }else if(s=="SUCCESS"){
   if(bBuff)cb.Run(make_pair(++iLC,sBuff));
   cb.Run(make_pair(0,""));
   iLC=0;bBuff=false;sBuff="";return true;
  }else if(bBuff)cb.Run(make_pair(++iLC,sBuff));

  bBuff=true;sBuff=s;
 }
 return false;
}

CQModul::CQModul(Query_generic& _qc,const std::string& s):
  CModul(_qc),qgCon(_qc){
 Start_Query(s);
 iID=qgCon.LatestWriteID();
 error_flag.SetID(iID);
}

bool CQModul::Wait(bool b){
 if(error_flag.Err!=QMError_flag::QME_RUNNING)return true; //we are already done
 if(!b)
  return (CModul::Wait(false)&&qgCon.LatestReadID()==iID);

 while(!(CModul::Wait(true)&&qgCon.LatestReadID()==iID));
 return true;
}

void CQModul::operator()(const Arg& p){
 if(qgCon.LatestReadID()==iID){
  error_flag.Handle(p); 
  if(p.first<=0)StopCB();
  else Handle(p);
 }
}

void QMError_flag::Handle(const Query_generic::CallB::CBFunct::Arg& p){
 if(Err!=QME_RUNNING || p.first>0)return; //fast exit
 sMsg=p.second;
 switch(p.first){
  case  0:sErr="SUCCESS";Err=QME_SUCCESS;break;
  case -1:sErr="VOID";Err=QME_VOID;break;
  case -2:sErr="ERROR";Err=QME_ERROR;break;
  default:sMsg="";sErr="Running...";Err=QME_RUNNING;break;
 }
}

void QM_PageAlevt::Handle(const Arg& p){
 if(iLim && iLim<li.size()){StopCB();error_flag.Err=QMError_flag::QME_SUCCESS;}
 else if(pg.ReadLine(p.second))
   li.push_back(std::make_pair(PgInfo(p.second),pg));
}

void QM_Stations::Handle(const Arg& p){

 std::string s=p.second;
 std::pair<size_t,StInfo> si;
 si.second.sName=NextSep('\t',s);
 si.first=strtol(NextSep('\t',s).c_str(),NULL,10);
 si.second.sMatch=NextSep('\t',s);
 si.second.iTimeout=strtol(NextSep('\t',s).c_str(),NULL,10);
 si.second.iPageC=strtol(NextSep('\t',s).c_str(),NULL,10);
 si.second.tLatest=strtol(NextSep('\t',s).c_str(),NULL,10);
 
 sm.insert(si);
}
